Imports Microsoft.Xna.Framework

Namespace ViewHorizontalCoordinates
	Public Class HorizontalCoordinateProjection
		Private viewCenterVector, horzAxis, vertAxis As Vector3

		Public Sub SetViewCenter(ByVal viewCenterCoord As HorizontalCoordinate)
			viewCenterVector = viewCenterCoord.ToVector
			Dim vertAxisCoord As New HorizontalCoordinate(viewCenterCoord.Azimuth + 90, 0)
			vertAxis = vertAxisCoord.ToVector
			horzAxis = Vector3.Cross(viewCenterVector, vertAxis)
		End Sub

		Public Sub GetAngleOffsets(ByVal objectCoord As HorizontalCoordinate, <System.Runtime.InteropServices.Out> ByRef horzAngle As Double, <System.Runtime.InteropServices.Out> ByRef vertAngle As Double)
			Dim objectVector As Vector3 = objectCoord.ToVector
			Dim horzObjectCross As Vector3 = Vector3.Cross(objectVector, -horzAxis)
			Dim vertObjectCross As Vector3 = Vector3.Cross(objectVector, vertAxis)

			horzObjectCross.Normalize()
			vertObjectCross.Normalize()

			Dim x As Double = Vector3.Dot(horzObjectCross, vertAxis)
			Dim y As Double = Vector3.Dot(horzObjectCross, viewCenterVector)
			horzAngle = -180 * Math.Atan2(y, x) / Math.PI

			x = Vector3.Dot(vertObjectCross, horzAxis)
			y = Vector3.Dot(vertObjectCross, viewCenterVector)
			vertAngle = -180 * Math.Atan2(y, x) / Math.PI
		End Sub
	End Class
End Namespace
